/*****************************************************************************
 *  CY256 Instrument Driver                               
 *  LabWindows/CVI Instrument Driver                                     
 *  Original Release: Monday, June 9th, 2014                                  
 *  By: Nicky Turner, Cytec Corp                              
 *      PH. 585-381-4740                                
 *                                                                           
 *  Modification History:                                                    
 *                                                                           
 *       Monday, June 9th, 2014 - Instrument Driver Created.                  
 *                                                                           
 *****************************************************************************/

#include <objbase.h>
#include <cvirte.h>     
#include "toolbox.h"
#include <utility.h>
#include <formatio.h>
#include <cytecswitch.h> 
#include <string.h>
#include <stdio.h>  
#include <ctype.h>
#include <visa.h>
#include <ivi.h>
#include <stdlib.h>
#include <cy_if11.h>
#include <iviswtch.h>

#define SWITCH_SIZE 1000

typedef char * string;

/*===================Global Variable Definitions=============================*/
int initHandle,configHandle;
ViInt32 instrumentHandle = VI_NULL;
ViChar  helpPath[MAX_PATHNAME_LEN];
int err, mod, rly, instrID, status;           
short reset;
/*=================== Utility Function Declarations =========================*/
//void InitChannelList(void);
//void CVICALLBACK DriverError (void *callbackData);
//void ShowHelp (char topic[]);
//void InitHelp (void);   
//ViStatus resourcemanager (void);

//static ViString configChnArr[SWITCH_SIZE];
static ViString canConnectArr[] = 
{"", //empty string attribute is one based avoid having to subract one       

    "CY256_VAL_PATH_AVAILABLE\n"
    "(1) - Indicates that the driver can create a path at this time.",
    
    "CY256_VAL_PATH_EXISTS\n"
    "(2) - Indicates that the explicit path between the channels already exists.",
    
    "CY256_VAL_PATH_UNSUPPORTED\n"
    "(3) - Indicates that the instrument is not capable of creating a path between the two channels.",
    
    "CY256_VAL_RSRC_IN_USE\n"
    "(4) - Indicates that although the path is valid, the driver cannot create the path at this\n"
    "moment because the switch module is currently using one or more of the required channels \n"
    "to create another path.  You must destroy the other path before creating this one.",
    
    "CY256_VAL_SOURCE_CONFLICT\n"
    "(5) - Indicates that the instrument cannot create a path between the two channels because\n"
    "both are connected to a different source channel.",
    
    "CY256_VAL_CHANNEL_NOT_AVAILABLE\n"
    "(6) - Indicates that the driver cannot create a path between the two channels because one\n"
    "of the channels is a configuration channel and thus unavailable for external connections."
};

                       
/*****************************************************************************/
/*=== Begin UIR SOURCE CODE =================================================*/
/*****************************************************************************/

int main (int argc, char *argv[])
{   
    err = 0;
    if (InitCVIRTE (0, argv, 0) == 0)   /* Needed if linking in external compiler; harmless otherwise */
        return -1;  /* out of memory */
        
  /*  CoInitialize (NULL);  */
    initHandle = LoadPanel(0, "cytecswitch.uir", INIT);
   // checkErr(configHandle = LoadPanel (0, "cytecswitch.uir", CONFIG));
    //SetCtrlVal (initHandle, INIT_DRIVER, "Enter Address");
    DisplayPanel (initHandle);
   // InitHelp ();
    RunUserInterface ();
    
    return err;
}

/**************************************************************************** 
 *  Function: init                                              
 *  Purpose:  Close the session to the instrument and quit the user interface 
 *            manager. 
 ****************************************************************************/
      
int CVICALLBACK initCytecSwitch(int panel, int control, int event, void *callbackData,
                int eventData1, int eventData2)
{
   

    switch (event) 
        {
        case EVENT_COMMIT:
			
		//	GetCtrlVal (initHandle, INIT_ID_QUERY, &IDQuery);
            GetCtrlVal (initHandle, INIT_RESET, &reset);
            GetCtrlVal (initHandle, INIT_ADDRESS, &instrID);
			
			err = if11_init (instrID, reset, &instrID);
			if (err) {
				FmtOut("Error Initializing Cytec IF-11.\n");
				return -1;
			}
			
            break;
            
        case EVENT_RIGHT_CLICK:
           
            break;
        }

    return 0;
}

/**************************************************************************** 
 *  Function: Quit                                              
 *  Purpose:  Close the session to the instrument and quit the user interface 
 *            manager. 
 ****************************************************************************/
int CVICALLBACK Quit(int panel, int control, int event, void *callbackData,
          int eventData1, int eventData2)
{
    

    switch (event) 
        {
        case EVENT_COMMIT:
        
                /* Close the session to the instrument */
               if11_close(instrID); 
                QuitUserInterface (0);
            break;
        case EVENT_RIGHT_CLICK:
            
            break;
        }
    return 0;
}




/*****************************************************************************/
/*=== END UIR SOURCE CODE ===================================================*/
/*****************************************************************************/
